Subject: Re: [PATCH v2 00/33] Per-VMA locks

From: Andrew Morton <[email-masked]>
Date: Fri, 27 Jan 2023 14:51:38 -0800

On Fri, 27 Jan 2023 11:40:37 -0800 Suren Baghdasaryan <[email-masked]> wrote:

> Per-vma locks idea that was discussed during SPF [1] discussion at LSF/MM
> last year [2], which concluded with suggestion that “a reader/writer
> semaphore could be put into the VMA itself; that would have the effect of
> using the VMA as a sort of range lock. There would still be contention at
> the VMA level, but it would be an improvement.” This patchset implements
> this suggested approach.

I think I'll await reviewer/tester input for a while.

> The patchset implements per-VMA locking only for anonymous pages which
> are not in swap and avoids userfaultfs as their implementation is more
> complex. Additional support for file-back page faults, swapped and user
> pages can be added incrementally.

This is a significant risk.  How can we be confident that these as yet
unimplemented parts are implementable and that the result will be good?